package de.mdelab.mlsdm.interpreter.debug.ui;

import org.eclipse.debug.core.DebugException;

import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlsdm.Activity;
import de.mdelab.sdm.interpreter.code.debug.ui.SDDebugTarget;
import de.mdelab.sdm.interpreter.code.debug.ui.SDDebugThread;
import de.mdelab.sdm.interpreter.code.debug.ui.SDDebugUiStackFrame;
import de.mdelab.sdm.interpreter.core.debug.client.stack.DebugClientStackFrame;

public class MLSDMDebugUiStackFrame extends SDDebugUiStackFrame<MLElementWithUUID>
{

	public MLSDMDebugUiStackFrame(final SDDebugTarget<MLElementWithUUID, Activity> target,
			final SDDebugThread<MLElementWithUUID, Activity> debugThread, final DebugClientStackFrame<MLElementWithUUID> stackFrame)
	{
		super(target, debugThread, stackFrame);
		// TODO Auto-generated constructor stub
	}

	@Override
	public String getName() throws DebugException
	{
		if (this.getStackFrame().getStoryDiagramElement().eResource() != null)
		{
			final StringBuilder stringBuilder = new StringBuilder();

			stringBuilder.append(this.getStackFrame().getStoryDiagramElement().eResource().getURI().lastSegment());
			stringBuilder.append(": ");

			if ((this.getStackFrame().getStoryDiagramElement() instanceof MLNamedElement)
					&& (((MLNamedElement) this.getStackFrame().getStoryDiagramElement()).getName() != null))
			{
				stringBuilder.append(((MLNamedElement) this.getStackFrame().getStoryDiagramElement()).getName());
				stringBuilder.append(":");
			}

			stringBuilder.append(this.getStackFrame().getStoryDiagramElement().eClass().getName());

			stringBuilder.append(" (");

			// TODO: Insert a better readable string
			stringBuilder.append(this.getStackFrame().getLastNotificationType().toString());

			stringBuilder.append(")");

			return stringBuilder.toString();
		}
		else
		{
			return "";
		}
	}

}
