package de.mdelab.mlsdm.interpreter.debug.ui.breakpoints.view;


import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.widgets.Display;

public class BreakpointViewContentProvider implements IStructuredContentProvider, IBreakpointsManagerListener {
	
	private TableViewer viewer;
	private MLSDMBreakpointsManager manager;

	@Override
	public void dispose() { }

	@Override
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		this.viewer = (TableViewer)viewer;
		if(manager != null)
			manager.removeListener(this);
		manager = (MLSDMBreakpointsManager)newInput;
		if(manager != null)
			manager.addListener(this);
	}

	@Override
	public void breakpointChanged(final BreakpointsManagerEvent event) {
		
		Display.getDefault().syncExec(new Runnable()
		{
			@Override
			public void run()
			{
				viewer.getTable().setRedraw(false);
				try {
					ISDBreakpointItem item = event.getItem();
					if(item != null)
						switch (event.getChangeType()) {
						case BreakpointsManagerEvent.REMOVED:
							viewer.remove(item);
							break;
						case BreakpointsManagerEvent.ADDED:
							viewer.add(item);
							break;		
						case BreakpointsManagerEvent.CHANGED:
							viewer.update(item, null);
							break;
						default:
							break;
						}
				} finally {
					viewer.getTable().setRedraw(true);
				}
			}
		});
	}

	@Override
	public Object[] getElements(Object inputElement) {
		return manager.getBreakPointItems();
	}

}
