package de.mdelab.mlsdm.interpreter.debug.ui.instanceGraph;

import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.edit.domain.AdapterFactoryEditingDomain;
import org.eclipse.emf.transaction.TransactionalEditingDomain;

import de.mdelab.sdm.interpreter.code.debug.ui.instanceGraph.SDInstanceGraphEditor;

/**
 * The InstanceGraphEditor shows the complete instance graph of the debugged
 * story diagram (including the story diagram itself). The editing domain of
 * this editor is also used by the GMF story diagram editors. These require a
 * transactional editing domain. Therefore, the initialization of the editing
 * domain is customized here.
 * 
 * @author Stephan Hildebrandt
 * 
 */
public class MLSDMInstanceGraphEditor extends SDInstanceGraphEditor
{

	@Override
	protected AdapterFactoryEditingDomain createEditingDomain(ResourceSet debuggerResourceSet)
	{
		return (AdapterFactoryEditingDomain) TransactionalEditingDomain.Factory.INSTANCE.createEditingDomain(debuggerResourceSet);
	}

}
