package de.mdelab.mlsdm.interpreter.debug.ui.instanceGraph.actions;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceImpl;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.ui.IActionDelegate;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;

import de.mdelab.instanceGraphEditor.ui.editor.InstanceGraphEditorInput;
import de.mdelab.mlsdm.interpreter.debug.ui.breakpoints.MLSDMDebugUiConstants;

public class OpenInstanceGraphEditorAction implements IObjectActionDelegate {

	//private Shell shell;
	
	private Resource resource;
	
	private EObject object;
	
	/**
	 * Constructor for Action1.
	 */
	public OpenInstanceGraphEditorAction() {
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	@Override
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
		//shell = targetPart.getSite().getShell();
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	@Override
	public void run(IAction action) {
		
		IWorkbenchPage page = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
		
		InstanceGraphEditorInput editorInput = new InstanceGraphEditorInput(resource, object);
		
		try {
			page.openEditor(editorInput,	MLSDMDebugUiConstants.INSTANCE_GRAPH_EDITOR_ID);
		} catch (PartInitException e) {
			e.printStackTrace();
		}
	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	@Override
	public void selectionChanged(IAction action, ISelection selection) {
		
		Object o = ((StructuredSelection)selection).getFirstElement();

		if ( o !=null){
			
			if (o instanceof XMIResourceImpl){
				resource = (Resource)o;
				this.object = (EObject) resource.getContents().get(0);
			}
			else if(o instanceof EObject){
				object = (EObject)o;
				resource = object.eResource();
			}

		}

	}

}
