package de.mdelab.mlsdm.interpreter.debug.ui.mlsdmEditor;


import org.eclipse.emf.common.ui.URIEditorInput;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.ui.IMemento;

import de.mdelab.mlsdm.interpreter.debug.ui.MLSDMDebugUiPlugin;
import de.mdelab.resourceSetSynchronizer.SynchronizerAdapter;

public class MLSDMDebuggerEditorInput extends URIEditorInput
{
	public static final String	SERVER_PORT_TAG	= "serverPort";
	public static final String	ACTIVITY_UUID	= "activityUUID";

	private String				activityUUID;

	private SynchronizerAdapter	synchronizerAdapter;

	private EditingDomain		editingDomain;

	public MLSDMDebuggerEditorInput(URI uri, EditingDomain editingDomain, String activityUUID)
	{
		super(uri);

		this.editingDomain = editingDomain;
		this.activityUUID = activityUUID;
	}

	public MLSDMDebuggerEditorInput(IMemento memento)
	{
		super(memento);
	}

	@Override
	protected String getBundleSymbolicName()
	{
		return MLSDMDebugUiPlugin.PLUGIN_ID;
	}

	@Override
	protected void loadState(IMemento memento)
	{
		super.loadState(memento);
	}

	@Override
	public void saveState(IMemento memento)
	{
		super.saveState(memento);
	}

	public SynchronizerAdapter getSynchronizerAdapter()
	{
		return this.synchronizerAdapter;
	}

	public void setSynchronizerAdapter(SynchronizerAdapter synchronizerAdapter)
	{
		this.synchronizerAdapter = synchronizerAdapter;
	}

	public String getActivityUUID()
	{
		return this.activityUUID;
	}

	public EditingDomain getEditingDomain()
	{
		return this.editingDomain;
	}
}
