package de.mdelab.mlsdm.interpreter.debug.ui.mlsdmEditor;


import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IPersistableElement;

public class MLSDMDebuggerResourceEditorInput implements IEditorInput
{
	private final Resource	resource;

	public MLSDMDebuggerResourceEditorInput(Resource resource)
	{
		this.resource = resource;
	}

	@Override
	public boolean equals(Object obj)
	{
		if (obj instanceof MLSDMDebuggerResourceEditorInput)
		{
			return this.resource == ((MLSDMDebuggerResourceEditorInput) obj).resource;
		}
		else
		{
			return super.equals(obj);
		}
	}

	@Override
	public boolean exists()
	{
		return false;
	}

	@Override
	public ImageDescriptor getImageDescriptor()
	{
		return ImageDescriptor.getMissingImageDescriptor();
	}

	@Override
	public String getName()
	{
		return this.resource.getURI().lastSegment();
	}

	@Override
	public IPersistableElement getPersistable()
	{
		return null;
	}

	@Override
	public String getToolTipText()
	{
		return this.resource.getURI().toString();
	}

	@Override
	public Object getAdapter(@SuppressWarnings("rawtypes") Class adapter)
	{
		return null;
	}

	public Resource getResource()
	{
		return this.resource;
	};
}
