package de.mdelab.mlsdm.interpreter.debug.ui.mlsdmEditor;


import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gmf.runtime.diagram.ui.resources.editor.document.IDocumentProvider;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.part.ShowInContext;

import de.mdelab.mlsdm.diagram.part.MlsdmDiagramEditor;

public class MLSDMDebuggerStoryDiagramEditor extends MlsdmDiagramEditor
{
	public static final String			ID	= "de.mdelab.mlsdm.interpreter.debug.ui.mlsdmEditor.MLSDMDebuggerStoryDiagramEditor.ID";	//$NON-NLS-1$
	
	private MLSDMDebuggerDocumentProvider	documentProvider;

	@Override
	protected IDocumentProvider getDocumentProvider(IEditorInput input)
	{
		assert input instanceof MLSDMDebuggerResourceEditorInput;

		if (this.documentProvider == null)
		{
			this.documentProvider = new MLSDMDebuggerDocumentProvider();
		}

		return this.documentProvider;
	}

	@Override
	protected void setDocumentProvider(IEditorInput input)
	{
		this.setDocumentProvider(new MLSDMDebuggerDocumentProvider());
	}

	@Override
	public boolean isSaveAsAllowed()
	{
		return false;
	}

	@Override
	public void doSaveAs()
	{
		throw new UnsupportedOperationException();
	}

	@Override
	public void doSave(IProgressMonitor progressMonitor)
	{
		super.doSave(progressMonitor);
	}

	@Override
	protected void performSave(boolean overwrite, IProgressMonitor progressMonitor)
	{
		super.performSave(overwrite, progressMonitor);
	}

	@Override
	protected void performSaveAs(IProgressMonitor progressMonitor)
	{
		// Do nothing
	}

	@Override
	public ShowInContext getShowInContext()
	{
		return null;
	}

	@Override
	public boolean isDirty()
	{
		return false;
	}

	@Override
	public boolean isEditorInputModifiable()
	{
		return true;
	}

	@Override
	public boolean isEditable()
	{
		return true;
	}

	@Override
	public boolean isEditorInputReadOnly()
	{
		return false;
	}

	@Override
	public boolean isSaveOnCloseNeeded()
	{
		return false;
	}

	@Override
	public boolean isWritable()
	{
		return true;
	}

	@Override
	public TransactionalEditingDomain getEditingDomain()
	{
		return (TransactionalEditingDomain) ((MLSDMDebuggerEditorInput) this.getEditorInput()).getEditingDomain();
	}
}
