package de.mdelab.mlsdm.interpreter.debug.ui.perspective;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;

public class MLSDMDebugPerspective implements IPerspectiveFactory {
	
	String MLSDMDEBUG_VIEW_ID = "de.mdelab.mlsdm.interpreter.debug.ui.MLSDMDebugView";
	String BREAKPOINT_VIEW_ID = "de.mdelab.mlsdm.interpreter.debug.ui.BreakpointsView";

	@Override
	public void createInitialLayout(IPageLayout layout) {
		layout.setFixed(true);
		String editorArea = layout.getEditorArea();
		{
			IFolderLayout folderLayout = layout.createFolder("folder_1", IPageLayout.TOP, 0.4f, IPageLayout.ID_EDITOR_AREA);
			folderLayout.addView(MLSDMDEBUG_VIEW_ID);
		}
		layout.addView("org.eclipse.ui.console.ConsoleView", IPageLayout.BOTTOM, 0.5f, IPageLayout.ID_EDITOR_AREA);
		layout.addView("org.eclipse.debug.ui.DebugView", IPageLayout.RIGHT, 0.5f, "org.eclipse.ui.console.ConsoleView");
		layout.addView("org.eclipse.ui.views.ContentOutline", IPageLayout.RIGHT, 0.66f, IPageLayout.ID_EDITOR_AREA);
		{
			IFolderLayout folderLayout = layout.createFolder("folder", IPageLayout.RIGHT, 0.5f, MLSDMDEBUG_VIEW_ID);
			folderLayout.addView(BREAKPOINT_VIEW_ID);
			folderLayout.addView("org.eclipse.debug.ui.VariableView");
		}
		layout.addActionSet("org.eclipse.debug.ui.launchActionSet");
	}

}
